\ mini.fth to generate a mini parser and test it for both options of Grace
\ and for the Gray emulator
\ Version for use with GForth

.( Loading mini.fth ... ) cr
\ -----------------------------------------------------------------------------

[defined] reset-all [if] reset-all [then]
marker reset-all

0 constant [bnf-in]
1 constant [forth-out]

1 constant verbose

marker reset
s" ..\graceloader.fth" included

[forth-out] [if]
   s" minitokens.fth" included
   [bnf-in] [if]                          \ Mode 3
      s" minidefs.fth" included
      s" minitokens.fth" included
      s" grace\mini\mini.bnf" grace
      s" grace\mini\miniparser1.fth" generate-forth
   [else]
      s" minidefs_gray.fth" included      \ Mode 2
      s" minitokens.fth" included
      s" grace\mini\mini.gry" save-filename
      s" grace\mini\miniparser2.fth" generate-forth
   [then]
   reset
   marker reset
   s" ..\library\ansify.fth" included
   s" ..\library\xmini_oof.fth" included
   s" ..\library\inputsources.fth" included
   s" ..\mini\ministt.fth" included
   s" ..\library\lexscanner2_0.fth" included
   s" minitokens.fth" included
   s" minirun.fth" included
   [bnf-in] [if]
      s" miniparser1.fth" included
   [else]
      s" miniparser2.fth" included
   [then]
[then]

[forth-out] 0= [bnf-in] 0= and [if]       \ Mode 0, Gray emulator
   s" ..\library\files.fth" included
   s" ministt.fth" included
   s" ..\library\lexscanner2_0.fth" included
   s" minitokens.fth" included
   s" miniactions_gray.fth" included
   s" minitokens.fth" included
   s" mini.gry" included
[then]

[forth-out] 0= [bnf-in] and [if]          \ Mode 1
   s" ministt.fth" included
   s" minitokens.fth" included
   s" miniactions.fth" included
   s" minitokens.fth" included
   s" grace\mini\mini.bnf" grace
   compile-mini
[then]

.( mini.fth loaded ) .s cr

\ [forth-out] 0= [run] or [if]
   \ -----------------------------------------------------------------------
   \ Compile and run the Mini program square.mini, which squares the number
   \ provided on the stack and displays the result
   cr .( --------------------------------------------------)
   cr .( Compiling square.mini with...)
   cr .( s" grace\mini\square.mini" mini) cr cr
   s" grace\mini\square.mini" mini
   cr cr .( Executing the mini program called square with...)
   cr .( 125 square)
   cr .( should give the result 15625) cr
   125 square cr
   .( --------------------------------------------------) cr
\ [then]

