\ minidefs.fth for use with the mini language example
\ It handles the mode with the grammar in conventional BNF format and
\ generation of a Forth standalone parser

\ Note the change in the definition of token which declares a terminal in
\ the terminal-wordlist

.( Loading minidefs.fth...) cr

\ ---[ Gray interface ]--------------------------------------------------------

tokenval @ 1- max-member      \ The token set size

\ ---[ Redefinition of token ]-------------------------------------------------
\ token has to be redefined when the tokens file is read for a second time
\ during the loading of the Gray system. This new definition will create
\ Gray terminals with the same name as the tokens. It gets the token value
\ for each terminal from the constant with the same name.
\ Note that this definition uses the alternative stack diagram for terminal
\ where the name of the check&next word is passed to Grace. As this mode uses
\ the Grace BNF parser the terminal is now defined in the terminal-wordlist,
\ hence the need for get-current and set-current

: token
   get-current                         ( -- wid )
   >in @ ' execute                     ( -- wid n1 n2 )
   swap >in !                          ( -- wid n2 )
   terminal-wordlist set-current
   singleton s" ?nextsym" 0 terminal   ( -- wid )
   set-current                         ( -- )
;

\ ---[ To generate Forth source code ]------------------------------------------

\ (caddr u) is the output file name

: generate-forth  ( syntax-expr caddr u -- )
   createFile setCurrentFile
   preamble
   s" parser this-parser" evaluate
   s" ' this-parser to parser-name" evaluate
   save-first-sets
   closeFile
;

\ -----------------------------------------------------------------------------

.( minidefs.fth loaded ) .s
