\ minidefs_gray.fth for use with the mini language example
\ It handles the mode with the grammar in Gray format and generation of a
\ Forth standalone parser


.( Loading minidefs_gray.fth...) cr

\ ---[ Interface to Gray ]------------------------------------------------------

tokenval @ 1- max-member      \ The token set size

\ ---[ Redefinition of token ]-------------------------------------------------
\ token has to be redefined when the tokens file is read for a second time
\ during the loading of the Gray system. This new definition will create
\ Gray terminals with the same name as the tokens. It gets the token value
\ for each terminal from the constant with the same name.
\ Note that this definition uses the alternative stack diagram for terminal
\ where the name of the check&next word is passed to Grace.

: token
   >in @ ' execute                     ( -- n1 n2 )
   swap >in !                          ( -- n2 )
   singleton s" ?nextsym" 0 terminal   ( -- )
;

\ ---[ To generate Forth source code ]------------------------------------------

128 constant fnbuf-size
create fnbuf fnbuf-size allot

: save-filename  ( caddr u -- caddr2 u )
   dup fnbuf-size > abort" Grace::save-filename - name too long for buf"
   >r fnbuf r@ move fnbuf r>
;

\ (caddr1 u1) is the .gry source file. (caddr2 u2) is the output file

: generate-Forth  ( caddr1 u1 caddr2 u2 -- )
   createFile setCurrentFile
   preamble
   included
   save-first-sets
   closeFile
;

\ -----------------------------------------------------------------------------

.( minidefs_gray.fth loaded ) .s
